/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code shows how to place a pixmap on a label (and 
therefore on a button or in a menu).
***************************************************************/

/* label_pixmap.c */

#include <Xm/Xm.h>
#include <Xm/Label.h>
#include "folder.xbm"

XtAppContext context;

Widget toplevel, label;

unsigned int get_depth(w)
    Widget w;
/* gets the depth of the display holding w. */
{
    Window r;
    unsigned int x,y,wd,ht,bw,depth;

    XGetGeometry(XtDisplay(w), RootWindowOfScreen(XtScreen(toplevel)),
        &r,&x,&y,&wd,&ht,&bw,&depth);
    return depth;
}

main(argc,argv)
    int argc;
    char *argv[];
{
    Arg al[10];
    int ac;
    int foreground,background;
    Pixmap pix;
    unsigned int depth;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,
        NULL,NULL,0);

    /* attach the pixmap to the label as it is created. */
    ac=0;
    label=XmCreateLabel(toplevel,"label",al,ac);
    XtManageChild(label);

    /* get colors of label */
    ac=0;
    XtSetArg(al[ac], XmNforeground, &foreground); ac++;
    XtSetArg(al[ac], XmNbackground, &background); ac++;
    XtGetValues(label, al, ac);

    /* get the depth so pixmap can be created. */
    depth=get_depth(toplevel);

    /* create the pixmap */
    pix=XCreatePixmapFromBitmapData(XtDisplay(toplevel),
        RootWindowOfScreen(XtScreen(toplevel)),
        folder_bits,folder_width,folder_height,
        foreground,background,depth);

    /* set appropriate label resources. */
    ac=0;
    XtSetArg(al[ac], XmNlabelType, XmPIXMAP); ac++;
    XtSetArg(al[ac], XmNlabelPixmap, pix); ac++;
    XtSetArg(al[ac], XmNshadowThickness, 4); ac++;
    XtSetValues(label, al, ac);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
